Bug 903380 (libint2) - Review Request: libint2 - A library for efficient evaluation of electron repulsion integrals
Summary: Review Request: libint2 - A library for efficient evaluation of electron repu...
Keywords:
Status: CLOSED ERRATA
Alias: libint2
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Alex G.
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-01-23 20:56 UTC by Susi Lehtola
Modified: 2014-09-02 12:35 UTC (History)
4 users (show)

Fixed In Version: libint2-2.0.3-2.641hg.el5
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-30 02:58:36 UTC
mr.nuke.me: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)
fix spec issues (1.51 KB, patch)
2013-02-18 23:32 UTC, Dominik 'Rathann' Mierzejewski
no flags Details | Diff

Description Susi Lehtola 2013-01-23 20:56:19 UTC
Spec URL: 
http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2.spec

SRPM URL: 
http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2-2.0.0-1.607hg.fc18.src.rpm

Description:
LIBINT computes the Coulomb and exchange integrals, which in electronic
structure theory are called electron repulsion integrals (ERIs). This is by
far the most common type of integrals in molecular structure theory.

LIBINT uses recursive schemes that originate in seminal Obara-Saika method and
Head-Gordon and Pople’s variation thereof. The idea of LIBINT is to optimize
computer implementation of such methods by implementing an optimizing compiler
to generate automatically highly-specialized code that runs well on
super-scalar architectures.

Fedora Account System Username:
jussilehtola


Libint2 is API incompatible with Libint 1 which is already in Fedora, so that's why there is a need for a new package.

Comment 1 Dominik 'Rathann' Mierzejewski 2013-02-18 23:32:36 UTC
Created attachment 699221 [details]
fix spec issues

Looks like it doesn't build out-of-the-box at least on F18/x86_64 (in mock). Attached patch to fix the missing TeX dependencies and some rpmlint issues (-devel not depending on main package).

Comment 3 Dominik 'Rathann' Mierzejewski 2013-02-19 22:02:05 UTC
Why are you using Mercurial snapshot instead of released tarball?

http://downloads.sourceforge.net/project/libint/libint-for-mpqc/libint-2.0.0-stable.tgz

Comment 4 Susi Lehtola 2013-02-19 22:08:47 UTC
(In reply to comment #3)
> Why are you using Mercurial snapshot instead of released tarball?
> 
> http://downloads.sourceforge.net/project/libint/libint-for-mpqc/libint-2.0.0-
> stable.tgz

It's because that one is not the compiler, it's a generated source code tarball. The compiler doesn't have tarball releases.

Comment 5 Eugene A. Pivnev 2013-04-06 15:55:00 UTC
Depricated:
* %clean section
* rm -rf %{buildroot}
* %defattr(-,root,root,-)

http://fedoraproject.org/wiki/Packaging:Guidelines#.25clean
http://fedoraproject.org/wiki/Packaging:Guidelines#File_Permissions

Try "fedora-review -r -n <srpm_path>" localy - I get error checking this bug.

Comment 6 Susi Lehtola 2013-04-09 20:36:17 UTC
(In reply to comment #5)
> Depricated:
> * %clean section
> * rm -rf %{buildroot}
> * %defattr(-,root,root,-)

Not in EPEL5.
 
> Try "fedora-review -r -n <srpm_path>" localy - I get error checking this bug.

Uhm.. I get a single fail in the SHOULD section, namely that parallel make is not enabled... which is spurious.

Comment 7 Alex G. 2013-05-06 17:09:56 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[ ]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
[x]: Sources contain only permissible code or content.
[ ]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[-]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     libint2-devel
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 2 files have unknown
     license. Detailed output of licensecheck in
     /home/mrnuke/rpmbuild/review/903380-libint2/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[!]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 911360 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: Uses parallel make.
[ ]: Buildroot is not present
     Note: Buildroot: present but not needed
[ ]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Reviewer should test that the package builds in mock.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libint2-2.0.0-2.607hg.fc18.x86_64.rpm
          libint2-devel-2.0.0-2.607hg.fc18.x86_64.rpm
libint2.x86_64: E: incorrect-fsf-address /usr/share/doc/libint2-2.0.0/LICENSE
libint2-devel.x86_64: W: spelling-error Summary(en_US) libint -> lib int, lib-int, lint
libint2-devel.x86_64: W: spelling-error %description -l en_US libint -> lib int, lib-int, lint
2 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint libint2 libint2-devel
libint2.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libint2-stable.so.1.1.0 /lib64/libm.so.6
libint2.x86_64: E: incorrect-fsf-address /usr/share/doc/libint2-2.0.0/LICENSE
libint2-devel.x86_64: W: spelling-error Summary(en_US) libint -> lib int, lib-int, lint
libint2-devel.x86_64: W: spelling-error %description -l en_US libint -> lib int, lib-int, lint
2 packages and 0 specfiles checked; 1 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
libint2 (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

libint2-devel (rpmlib, GLIBC filtered):
    libint2
    libint2-stable.so.1()(64bit)



Provides
--------
libint2:
    libint2
    libint2(x86-64)
    libint2-stable.so.1()(64bit)

libint2-devel:
    libint2-devel
    libint2-devel(x86-64)



Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-18-x86_64
Command line :/bin/fedora-review -b 903380

Comment 8 Alex G. 2013-05-06 17:10:12 UTC
-- MUST --
> [!]: Fully versioned dependency in subpackages, if present.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
>      libint2-devel

> Requires:	libint2 = %{version}-%{release}
This is incorrect. The -devel package dependency must be arch-specific.
https://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package


> libint2.x86_64: E: incorrect-fsf-address /usr/share/doc/libint2-2.0.0/LICENSE
The LICENSE file includes the following fsf address:
> Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
The correct address is:
51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
Please have upstream update their LICENSE file.

-- SHOULD --

> BuildRoot:
> rm -rf %{buildroot}
> %defattr
> %clean

If you plan to also package for EPEL5, I recommend you only keep the above in
the EPEL5 branch, and remove them from EPEL6 and Fedora branches.


> [!]: Large documentation must go in a -doc subpackage.
>      Note: Documentation size is 911360 bytes in 2 files.
I would recommend putting the programming manual (progman.pdf) in a separate
-doc or -devel-doc package. It accounts for the majority of the size of the
-devel rpm.

> [!]: Uses parallel make.
fedora-review identifies this as a fail. That's a flase positive. I can see 8
cc1plus processes spawn during the build.
> make -C doc
Can the documentation use parallel make?

> %{_libdir}/libint*.so.*
Please consider versioning here:
%{_libdir}/libint*.so.1*
This makes it very easy to catch soname version bumps, and is much safer than
undiscriminately accepting any library the build spits out.

Comment 9 Susi Lehtola 2013-05-06 20:14:29 UTC
(In reply to comment #7)
> [ ]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
>      Note: rm -rf %{buildroot} present but not required
> [ ]: Each %files section contains %defattr if rpm < 4.4
>      Note: %defattr present but not needed
> [ ]: Buildroot is not present
>      Note: Buildroot: present but not needed
> [ ]: Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
>      Note: %clean present but not required

I'm also targetting EPEL5 so these are necessary.

> [!]: Fully versioned dependency in subpackages, if present.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
>      libint2-devel

Added the %{?_isa}.

> [!]: Large documentation must go in a -doc subpackage.
>      Note: Documentation size is 911360 bytes in 2 files.

I'm following the same rationale as in libint. This is a highly specialized package, and is only going to be installed by developers, for which the documentation is very much important, since the library is pretty much useless without it (requires many pages worth of initializing procedures).

(Note that the compiled library itself is 201MB!)


(In reply to comment #8)
> > libint2.x86_64: E: incorrect-fsf-address /usr/share/doc/libint2-2.0.0/LICENSE
> The LICENSE file includes the following fsf address:
> > Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
> The correct address is:
> 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
> Please have upstream update their LICENSE file.

I'll ask upstream to perform the update, and possibly add a proper COPYING file as well.


> If you plan to also package for EPEL5, I recommend you only keep the above in
> the EPEL5 branch, and remove them from EPEL6 and Fedora branches.

There's no sense in multiplying the workload without any added benefit. The obsoleted stuff doesn't hurt anything.

> > [!]: Uses parallel make.
> fedora-review identifies this as a fail. That's a flase positive. I can see 8
> cc1plus processes spawn during the build.
> > make -C doc
> Can the documentation use parallel make?

Not really - it's about running LaTeX on a single file, and doxygen.

> > %{_libdir}/libint*.so.*
> Please consider versioning here:
> %{_libdir}/libint*.so.1*
> This makes it very easy to catch soname version bumps, and is much safer than
> undiscriminately accepting any library the build spits out.

Well, in the case of libint sonames don't have much use anyway, since in my experience one can break the ABI compatibility just by changing the configure flags.

Comment 10 Alex G. 2013-05-06 20:31:30 UTC
(In reply to comment #9)

> > [!]: Fully versioned dependency in subpackages, if present.
> >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
> >      libint2-devel
> 
> Added the %{?_isa}.
> 
Where is the new .spec ?

> > [!]: Large documentation must go in a -doc subpackage.
> >      Note: Documentation size is 911360 bytes in 2 files.
> 
> I'm following the same rationale as in libint. This is a highly specialized
> package, and is only going to be installed by developers, for which the
> documentation is very much important, since the library is pretty much
> useless without it (requires many pages worth of initializing procedures).
> 
> (Note that the compiled library itself is 201MB!)
> 
My rationale is that some developers (such as myself) like to install a minimal -devel package and read the documentation online. Now, a pdf file of < 1MB is not a big issue. It's your choice. This point is [x].

 
> (In reply to comment #8)
> > The correct address is:
> > 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
> > Please have upstream update their LICENSE file.
> 
> I'll ask upstream to perform the update, and possibly add a proper COPYING
> file as well.
>
Cool. Thanks. 
 
> > If you plan to also package for EPEL5, I recommend you only keep the above in
> > the EPEL5 branch, and remove them from EPEL6 and Fedora branches.
> 
> There's no sense in multiplying the workload without any added benefit. The
> obsoleted stuff doesn't hurt anything.
>
Ok. I accept your answer.
 
> > Can the documentation use parallel make?
> 
> Not really - it's about running LaTeX on a single file, and doxygen.
> 
Then it's not a problem.


> > > %{_libdir}/libint*.so.*
> > Please consider versioning here:
> > %{_libdir}/libint*.so.1*
> > This makes it very easy to catch soname version bumps, and is much safer than
> > undiscriminately accepting any library the build spits out.
> 
> Well, in the case of libint sonames don't have much use anyway, since in my
> experience one can break the ABI compatibility just by changing the
> configure flags.
OK.

Comment 11 Susi Lehtola 2013-05-06 20:38:51 UTC
(In reply to comment #10)
> (In reply to comment #9)
> 
> > > [!]: Fully versioned dependency in subpackages, if present.
> > >      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
> > >      libint2-devel
> > 
> > Added the %{?_isa}.
> > 
> Where is the new .spec ?

Since you asked for it...

http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2.spec
http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2-2.0.0-3.607hg.fc18.src.rpm

Comment 12 Alex G. 2013-05-06 20:46:13 UTC
> Since you asked for it...
> 
> http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2.spec
> http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2-2.0.0-3.607hg.fc18.
> src.rpm

The .spec link still has the 2.0.0-2, but I was able to get the correct .spec from the new srpm.

Since I see no blockers, this package is APPROVED :) .

Best wishes on your studies/research! I'm just about to finish my undergrad studies soonish.

Comment 13 Susi Lehtola 2013-05-06 20:50:12 UTC
(In reply to comment #12)
> > Since you asked for it...
> > 
> > http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2.spec
> > http://theory.physics.helsinki.fi/~jzlehtol/rpms/libint2-2.0.0-3.607hg.fc18.
> > src.rpm
> 
> The .spec link still has the 2.0.0-2, but I was able to get the correct
> .spec from the new srpm.

You probably forgot to hit browser refresh ;)

> Since I see no blockers, this package is APPROVED :) .
> 
> Best wishes on your studies/research! I'm just about to finish my undergrad
> studies soonish.

Thanks, you too!

Comment 14 Susi Lehtola 2013-05-06 21:52:33 UTC
New Package SCM Request
=======================
Package Name: libint2
Short Description: A library for efficient evaluation of electron repulsion integrals
Owners: jussilehtola
Branches: F-18 F-19
InitialCC:

Comment 15 Gwyn Ciesla 2013-05-07 13:09:17 UTC
Git done (by process-git-requests).

Comment 16 Susi Lehtola 2013-05-12 16:46:30 UTC
Package Change Request
======================
Package Name: libint2
New Branches: EL-5 EL-6
Owners: jussilehtola
InitialCC:

Comment 17 Gwyn Ciesla 2013-05-12 17:30:13 UTC
Git done (by process-git-requests).

Comment 18 Fedora Update System 2013-05-13 10:33:05 UTC
libint2-2.0.2-2.618hg.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libint2-2.0.2-2.618hg.fc18

Comment 19 Fedora Update System 2013-05-13 10:33:39 UTC
libint2-2.0.2-2.618hg.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/libint2-2.0.2-2.618hg.el6

Comment 20 Fedora Update System 2013-05-13 10:33:47 UTC
libint2-2.0.2-2.618hg.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/libint2-2.0.2-2.618hg.el5

Comment 21 Fedora Update System 2013-05-13 17:47:38 UTC
libint2-2.0.2-2.618hg.el6 has been pushed to the Fedora EPEL 6 testing repository.

Comment 22 Fedora Update System 2013-05-21 13:05:58 UTC
libint2-2.0.3-2.641hg.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/libint2-2.0.3-2.641hg.fc19

Comment 23 Fedora Update System 2013-05-21 13:06:15 UTC
libint2-2.0.3-2.641hg.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/libint2-2.0.3-2.641hg.el6

Comment 24 Fedora Update System 2013-05-21 13:06:30 UTC
libint2-2.0.3-2.641hg.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libint2-2.0.3-2.641hg.fc18

Comment 25 Fedora Update System 2013-05-21 13:06:42 UTC
libint2-2.0.3-2.641hg.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/libint2-2.0.3-2.641hg.el5

Comment 26 Fedora Update System 2013-05-30 02:58:36 UTC
libint2-2.0.3-2.641hg.fc18 has been pushed to the Fedora 18 stable repository.

Comment 27 Fedora Update System 2013-05-30 03:36:42 UTC
libint2-2.0.3-2.641hg.fc19 has been pushed to the Fedora 19 stable repository.

Comment 28 Fedora Update System 2013-06-06 16:57:53 UTC
libint2-2.0.3-2.641hg.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 29 Fedora Update System 2013-06-06 16:58:31 UTC
libint2-2.0.3-2.641hg.el5 has been pushed to the Fedora EPEL 5 stable repository.

Comment 30 Susi Lehtola 2014-08-29 20:46:59 UTC
Package Change Request
======================
Package Name: libint2
New Branches: epel7
Owners: jussilehtola

Comment 31 Gwyn Ciesla 2014-09-02 12:35:46 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.